package com.engine.hrm.util;

import com.api.hrm.util.EncryptorAdaptationUtil;
import com.api.hrm.util.SystemSignCheckUtil;
import com.api.hrm.util.enums.SignModuleType;
import com.engine.hrm.cmd.matrix.biz.MatrixFieldsComInfo;
import com.engine.hrm.cmd.matrix.biz.MatrixinfoComInfo;
import org.apache.commons.lang.StringUtils;
import weaver.common.StringUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;
import weaver.hrm.city.CityComInfo;
import weaver.hrm.city.CitytwoComInfo;
import weaver.hrm.common.Tools;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.company.SubCompanyComInfo;
import weaver.hrm.companyvirtual.SubCompanyVirtualComInfo;
import weaver.hrm.country.CountryComInfo;
import weaver.hrm.definedfield.HrmFieldManager;
import weaver.hrm.job.*;
import weaver.hrm.location.LocationComInfo;
import weaver.hrm.moduledetach.ManageDetachComInfo;
import weaver.hrm.province.ProvinceComInfo;
import weaver.hrm.resource.ResourceComInfo;
import weaver.hrm.roles.RolesComInfo;
import weaver.security.util.SecurityMethodUtil;
import weaver.systeminfo.SystemEnv;
import weaver.systeminfo.systemright.CheckSubCompanyRight;
import weaver.systeminfo.systemright.RightComInfo;

import java.net.URLEncoder;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;

public class HrmTransMethod extends BaseBean {

    @SuppressWarnings("deprecation")
    public ArrayList<String> getCountryBaseOperate(String id1, String str, String reulst) {
        boolean isCancled = false;
        RecordSet rs = new RecordSet();
        rs.executeSql("select CANCELED from  hrmcountry where id =" + id1 + " ");
        if (rs.next()) {
            isCancled = rs.getString("CANCELED").equals("1");
        }
        ArrayList<String> resultList = new ArrayList<String>();
        String[] strings = str.split("_");

        if (isCancled) {
            resultList.add("false");
        } else {
            resultList.add(strings[0]);
        }

        if (reulst.equals("0") && !isCancled) {
            resultList.add(strings[1]);
        } else {
            resultList.add("false");
        }
        if (isCancled) {
            resultList.add("false");
            resultList.add(strings[0]);
        } else {
            resultList.add(strings[0]);
            resultList.add("false");
        }
        resultList.add(strings[2]);
        resultList.add(strings[3]);
        return resultList;
    }


    @SuppressWarnings("deprecation")
    public ArrayList<String> getProvinceBaseOperate(String id1, String str, String reulst) {
        ArrayList<String> resultList = new ArrayList<String>();
        String[] strings = str.split("_");
        boolean pRight = false;
        boolean editRight = false;
        try {
            ProvinceComInfo pComInfo = new ProvinceComInfo();
            CountryComInfo cComInfo = new CountryComInfo();
            String id = pComInfo.getProvincecountryid(id1);
            cComInfo.setTofirstRow();
            while (cComInfo.next()) {
                if (cComInfo.getCountryid().equals(id)) pRight = !cComInfo.getCountryiscanceled().equals("1");
            }
            pComInfo.setTofirstRow();
            while (pComInfo.next()) {
                if (pComInfo.getProvinceid().equals(id1)) editRight = !pComInfo.getProvinceiscanceled().equals("1");
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        if (pRight) {
            boolean isCancled = false;
            RecordSet rs = new RecordSet();
            rs.executeSql("select CANCELED from  hrmprovince where id =" + id1 + " ");
            if (rs.next()) {
                isCancled = rs.getString("CANCELED").equals("1");
            }
            if (editRight) {
                resultList.add(strings[0]);
            } else {
                resultList.add("false");
            }

            if (reulst.equals("0") && editRight) {
                resultList.add(strings[1]);
            } else {
                resultList.add("false");
            }

            if (isCancled) {
                resultList.add("false");
                resultList.add(strings[0]);
            } else {
                resultList.add(strings[0]);
                resultList.add("false");
            }
            resultList.add(strings[2]);
        } else {
            resultList.add("false");
            resultList.add("false");
            resultList.add("false");
            resultList.add("false");
        }
        resultList.add(strings[3]);
        return resultList;
    }


    @SuppressWarnings("deprecation")
    public ArrayList<String> getCityTwoBaseOperate(String id1, String str, String reulst) {
        ArrayList<String> resultList = new ArrayList<String>();
        String[] strings = str.split("_");
        boolean pRight = false;
        boolean editRight = false;
        try {
            CityComInfo pComInfo = new CityComInfo();
            CitytwoComInfo cComInfo = new CitytwoComInfo();
            String id = cComInfo.getCitypid(id1);
            pComInfo.setTofirstRow();
            while (pComInfo.next()) {
                if (pComInfo.getCityid().equals(id)) pRight = !pComInfo.getCitycanceled().equals("1");
            }

            cComInfo.setTofirstRow();
            while (cComInfo.next()) {
                if (cComInfo.getCityid().equals(id1)) editRight = !cComInfo.getCitycanceled().equals("1");
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        if (pRight) {

            boolean isCancled = false;
            RecordSet rs = new RecordSet();
            rs.executeSql("select CANCELED from  hrmcitytwo where id =" + id1 + " ");
            if (rs.next()) {
                isCancled = rs.getString("CANCELED").equals("1");
            }
            if (editRight) {
                resultList.add(strings[0]);
            } else {
                resultList.add("false");
            }
            if (reulst.equals("0") && editRight) {
                resultList.add(strings[1]);
            } else {
                resultList.add("false");
            }
            if (isCancled) {
                resultList.add("false");
                resultList.add(strings[0]);
            } else {
                resultList.add(strings[0]);
                resultList.add("false");
            }
            resultList.add(strings[2]);
        } else {
            resultList.add("false");
            resultList.add("false");
            resultList.add("false");
            resultList.add("false");
        }

        resultList.add(strings[3]);
        return resultList;
    }


    public ArrayList<String> getJobBaseOperate(String id1, String str, String reulst) {

        ArrayList<String> resultList = new ArrayList<String>();
        String[] strings = str.split("_");
        resultList.add(strings[0]);
        if (reulst.equals("0")) {
            resultList.add(strings[1]);
        } else {
            resultList.add("false");
        }
        resultList.add(strings[2]);
        return resultList;
    }


    public ArrayList<String> getJobTitleBaseOperate(String id1, String str) {
        ArrayList<String> resultList = new ArrayList<String>();
        try {
           JobTitlesComInfo JobTitlesComInfo= new JobTitlesComInfo();

            RecordSet recordSet = new RecordSet();
            String  sql  = "select * from HrmJobTitles where id =?";
            recordSet.executeQuery(sql, id1);
            String canceled1 =null;
            if(recordSet.next()){
                canceled1 = recordSet.getString("canceled");

            }


            // JobTitlesComInfo.setTofirstRow();
            boolean isCanceled =false;
            //String canceled = JobTitlesComInfo.getCanceled(id1);
            isCanceled="1".equals(canceled1);

            String[] strings = str.split("_");

            if(isCanceled){
                resultList.add("false");
            }else{
                resultList.add(strings[0]);
            }
            if(isCanceled){
                resultList.add("false");
            }else {
                if (strings[1].equals("true")) {
                    resultList.add(JobTitlesComInfo.getJobTitleCheckbox(id1));
                } else {
                    resultList.add(strings[1]);
                }
            }
            resultList.add(strings[2]);
            if(isCanceled){
                resultList.add("false");
                resultList.add(strings[3]);
            }else{
                resultList.add(strings[3]);
                resultList.add("false");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return resultList;
    }


    public ArrayList<String> getLocationBaseOperate(String id1, String str) {
        ArrayList<String> resultList = new ArrayList<String>();
        try {

            String[] strings = str.split("_");
            LocationComInfo comInfo = new LocationComInfo();
            String sign = comInfo.getLocationCheckbox(id1);
            resultList.add(strings[0]);
            if (strings[1].equals("true") && sign.equals("true")) {
                resultList.add("true");
            } else {
                resultList.add("false");
            }
            int strSize = Math.min(strings.length, 5);
            for (int i = 2; i < strSize; i++) {
                resultList.add(strings[i]);
            }
//            resultList.add(strings[2]);
//            resultList.add(strings[3]);
//            resultList.add(strings[4]);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return resultList;
    }


    public ArrayList<String> getSpecialityBaseOperate(String id1, String str) {
        ArrayList<String> resultList = new ArrayList<String>();
        try {

            String[] strings = str.split("_");
            SpecialityComInfo comInfo = new SpecialityComInfo();
            String sign = comInfo.getSpecialtityCheckbox(id1);
            resultList.add(strings[0]);
            if (strings[1].equals("true") && sign.equals("true")) {
                resultList.add("true");
            } else {
                resultList.add("false");
            }
            resultList.add(strings[2]);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return resultList;
    }


    @SuppressWarnings("deprecation")
    public ArrayList<String> getCityBaseOperate(String id1, String str, String reulst) {
        ArrayList<String> resultList = new ArrayList<String>();
        String[] strings = str.split("_");
        boolean pRight = false;
        boolean editRight = false;
        try {
            ProvinceComInfo pComInfo = new ProvinceComInfo();
            CityComInfo cComInfo = new CityComInfo();
            String id = cComInfo.getCityprovinceid(id1);
            pComInfo.setTofirstRow();
            while (pComInfo.next()) {
                if (pComInfo.getProvinceid().equals(id)) pRight = !pComInfo.getProvinceiscanceled().equals("1");
            }
            cComInfo.setTofirstRow();
            while (cComInfo.next()) {
                if (cComInfo.getCityid().equals(id1)) editRight = !cComInfo.getCitycanceled().equals("1");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (pRight) {
            boolean isCancled = false;
            RecordSet rs = new RecordSet();
            rs.executeSql("select CANCELED from  hrmcity where id =" + id1 + " ");
            if (rs.next()) {
                isCancled = rs.getString("CANCELED").equals("1");
            }
            if (editRight) {
                resultList.add(strings[0]);
            } else {
                resultList.add("false");
            }

            if (reulst.equals("0") && editRight) {
                resultList.add(strings[1]);
            } else {
                resultList.add("false");
            }
            if (isCancled) {
                resultList.add("false");
                resultList.add(strings[0]);
            } else {
                resultList.add(strings[0]);
                resultList.add("false");
            }
            resultList.add(strings[2]);
        } else {
            resultList.add("false");
            resultList.add("false");
            resultList.add("false");
            resultList.add("false");
        }
        resultList.add(strings[3]);
        return resultList;
    }


    public ArrayList<String> getJobGroupBaseOperate(String id, String str, String result) {

        ArrayList<String> resultList = new ArrayList<String>();
        String[] strings = str.split("_");
        resultList.add(strings[0]);
        if (strings[1].equals("true") && !result.equals("0")) {
            resultList.add(strings[1]);
        } else {
            resultList.add("false");
        }
        resultList.add(strings[2]);
        return resultList;
    }


    public String isCanceled(String showname, String lau, String cancled) {
        int laug = Integer.parseInt(lau);
        if (cancled.equals("1")) {
            return showname + "<span style='color:red;'>(" + SystemEnv.getHtmlLabelName(22205, laug) + ")</span>";
        } else {
            return showname;
        }
    }


    public boolean getJobCheckBox(String result) {
        return result.equals("0");
    }


    public String getCityBasicCheckbox(String id_batchkey) {
        id_batchkey = id_batchkey.replace("+", "_");
        String[] str1 = id_batchkey.split("_");
        CityComInfo comInfo = null;
        try {
            comInfo = new CityComInfo();
        } catch (Exception e) {
            e.printStackTrace();
        }
        String canceled = "";
        comInfo.setTofirstRow();
        while (comInfo.next()) {
            if (comInfo.getCityid().equals(str1[0])) {
                canceled = comInfo.getCitycanceled();
            }
        }
        String batchkey = str1[1];
        String flog = "false";
        if (batchkey.equals("0") && !canceled.equals("1")) {
            flog = "true";
        }
        if (batchkey.equals("1") && canceled.equals("1")) {
            flog = "true";
        }
        return flog;
    }

    public String getCityTwoBasicCheckbox(String id_batchkey) {
        id_batchkey = id_batchkey.replace("+", "_");
        String[] str1 = id_batchkey.split("_");
        CitytwoComInfo comInfo = null;
        try {
            comInfo = new CitytwoComInfo();
        } catch (Exception e) {
            e.printStackTrace();
        }
        String canceled = "";
        comInfo.setTofirstRow();
        while (comInfo.next()) {
            if (comInfo.getCityid().equals(str1[0])) {
                canceled = comInfo.getCitycanceled();
            }
        }
        String batchkey = str1[1];
        String flog = "false";
        if (batchkey.equals("0") && !canceled.equals("1")) {
            flog = "true";
        }
        if (batchkey.equals("1") && canceled.equals("1")) {
            flog = "true";
        }
        return flog;
    }

    public String getProvinceBasicCheckbox(String id_batchkey) {

        id_batchkey = id_batchkey.replace("+", "_");
        String[] str1 = id_batchkey.split("_");
        ProvinceComInfo comInfo = null;
        try {
            comInfo = new ProvinceComInfo();
        } catch (Exception e) {
            e.printStackTrace();
        }
        String canceled = "";
        comInfo.setTofirstRow();
        while (comInfo.next()) {
            if (comInfo.getProvinceid().equals(str1[0])) {
                canceled = comInfo.getProvinceiscanceled();
            }
        }
        String batchkey = str1[1];
        String flog = "false";
        if (batchkey.equals("0") && !canceled.equals("1")) {
            flog = "true";
        }
        if (batchkey.equals("1") && canceled.equals("1")) {
            flog = "true";
        }
        return flog;
    }


    public String getCountryBasicCheckbox(String id_batchkey) {
        id_batchkey = id_batchkey.replace("+", "_");
        String[] str1 = id_batchkey.split("_");
        CountryComInfo comInfo = null;
        try {
            comInfo = new CountryComInfo();
        } catch (Exception e) {
            e.printStackTrace();
        }
        String canceled = "";
        comInfo.setTofirstRow();
        while (comInfo.next()) {
            if (comInfo.getCountryid().equals(str1[0])) {
                canceled = comInfo.getCountryiscanceled();
            }
        }
        String batchkey = str1[1];
        String flog = "false";
        if (batchkey.equals("0") && !canceled.equals("1")) {
            flog = "true";
        }
        if (batchkey.equals("1") && canceled.equals("1")) {
            flog = "true";
        }
        return flog;
    }

    public String getSubCompanyCheckbox(String params) {
        String flag = "false";
        String[] param = Util.splitString(params, "+");
        int id = Util.getIntValue(param[0]);
        String batchOperateType = param.length > 1 ? param[1] : "";
        HrmOrganizationUtil hrmOrganizationUtil = new HrmOrganizationUtil();
        if (batchOperateType.equals("batchCancel")) {
            flag = String.valueOf(hrmOrganizationUtil.canCancelSubCompany(id));
        } else if (batchOperateType.equals("batchDoIsCanceled")) {
            flag = String.valueOf(hrmOrganizationUtil.canISCanceledSubCompany(id));
        } else if (batchOperateType.equals("batchDel")) {
            flag = String.valueOf(hrmOrganizationUtil.canDelSubCompany(id));
        }
        return flag;
    }

    /**
     * 下级分部 operate
     *
     * @param id
     * @param canEdit
     * @param otherPara
     * @return
     */
    public ArrayList<String> getSubcompanyListOperate(String strId, String canEdit) {
        ArrayList<String> resultList = new ArrayList<String>();
        HrmOrganizationUtil hrmOrganizationUtil = new HrmOrganizationUtil();
        SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
        int id = Util.getIntValue(strId);

        boolean isCanceled = Util.null2String(subCompanyComInfo.getCompanyiscanceled(strId)).equals("1");

        if (canEdit.equals("true")) {
            resultList.add(String.valueOf(!isCanceled));
            resultList.add(String.valueOf(hrmOrganizationUtil.canCancelSubCompany(id)));
            resultList.add(String.valueOf(hrmOrganizationUtil.canISCanceledSubCompany(id)));
            resultList.add(String.valueOf(hrmOrganizationUtil.canDelSubCompany(id)));
            resultList.add("true");
        }
        return resultList;
    }

    public String getSubCompanyVirtualCheckbox(String params) {
        String flag = "false";
        String[] param = Util.splitString(params, "+");
        int id = Util.getIntValue(param[0]);
        String batchOperateType = param.length > 1 ? param[1] : "";
        HrmOrganizationVirtualUtil hrmOrganizationVirtualUtil = new HrmOrganizationVirtualUtil();
        if (batchOperateType.equals("batchCancel")) {
            flag = String.valueOf(hrmOrganizationVirtualUtil.canCancelSubCompany(id));
        } else if (batchOperateType.equals("batchDoIsCanceled")) {
            flag = String.valueOf(hrmOrganizationVirtualUtil.canISCanceledSubCompany(id));
        } else if (batchOperateType.equals("batchDel")) {
            flag = String.valueOf(hrmOrganizationVirtualUtil.canDelSubCompany(id));
        }
        return flag;
    }

    /**
     * 下级分部 operate
     *
     * @param id
     * @param canEdit
     * @param otherPara
     * @return
     */
    public ArrayList<String> getSubcompanyVirtualListOperate(String strId, String canEdit) {
        ArrayList<String> resultList = new ArrayList<String>();
        HrmOrganizationVirtualUtil hrmOrganizationVirtualUtil = new HrmOrganizationVirtualUtil();
        SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
        int id = Util.getIntValue(strId);

        boolean isCanceled = Util.null2String(subCompanyComInfo.getCompanyiscanceled(strId)).equals("1");

        if (canEdit.equals("true")) {
            resultList.add(String.valueOf(!isCanceled));
            resultList.add(String.valueOf(hrmOrganizationVirtualUtil.canCancelSubCompany(id)));
            resultList.add(String.valueOf(hrmOrganizationVirtualUtil.canISCanceledSubCompany(id)));
            resultList.add(String.valueOf(hrmOrganizationVirtualUtil.canDelSubCompany(id)));
            resultList.add("true");
        }
        return resultList;
    }

    public String getDepartmentCheckbox(String params) {
        String flag = "false";
        String[] param = Util.splitString(params, "+");
        int id = Util.getIntValue(param[0]);
        String batchOperateType = param.length > 1 ? param[1] : "";
        HrmOrganizationUtil hrmOrganizationUtil = new HrmOrganizationUtil();
        if (batchOperateType.equals("batchCancel")) {
            flag = String.valueOf(hrmOrganizationUtil.canCancelDepartment(id));
        } else if (batchOperateType.equals("batchDoIsCanceled")) {
            flag = String.valueOf(hrmOrganizationUtil.canISCanceledDepartment(id));
        } else if (batchOperateType.equals("batchDel")) {
            flag = String.valueOf(hrmOrganizationUtil.canDelDepartment(id));
        }
        return flag;
    }

    public String getDepartmentVirtualCheckbox(String params) {
        String flag = "false";
        String[] param = Util.splitString(params, "+");
        int id = Util.getIntValue(param[0]);
        String batchOperateType = param.length > 1 ? param[1] : "";
        HrmOrganizationVirtualUtil hrmOrganizationUtil = new HrmOrganizationVirtualUtil();
        if (batchOperateType.equals("batchCancel")) {
            flag = String.valueOf(hrmOrganizationUtil.canCancelDepartment(id));
        } else if (batchOperateType.equals("batchDoIsCanceled")) {
            flag = String.valueOf(hrmOrganizationUtil.canISCanceledDepartment(id));
        } else if (batchOperateType.equals("batchDel")) {
            flag = String.valueOf(hrmOrganizationUtil.canDelDepartment(id));
        }
        return flag;
    }

    public String getImoprtResult(String allnum, String lauid, String succnum) {

        int failnum = Integer.parseInt(allnum) - Integer.parseInt(succnum);
        int languageid = Integer.parseInt(lauid);
        String str = SystemEnv.getHtmlLabelName(18609, languageid) + allnum + SystemEnv.getHtmlLabelName(30690, languageid) + ",";
        if (failnum > 0) {
            str += succnum + SystemEnv.getHtmlLabelName(10000674, Util.getIntValue(languageid));
        } else {
            str += SystemEnv.getHtmlLabelName(10000673, Util.getIntValue(languageid));
        }
        return str;
    }


    public String getOperateTypeName(String type, String lauid) {

        int languageid = Integer.parseInt(lauid);
        String str = SystemEnv.getHtmlLabelName(18596, languageid);
        return str;
    }


    public ArrayList<String> getEduBaseOperate(String id1, String str) {
        ArrayList<String> resultList = new ArrayList<String>();
        try {
            String[] strings = str.split("_");
            EducationLevelComInfo comInfo = new EducationLevelComInfo();
            String sign = comInfo.getEducationLevelCheckbox(id1);
            resultList.add(strings[0]);
            if (strings[1].equals("true") && sign.equals("true")) {
                resultList.add("true");
            } else {
                resultList.add("false");
            }
            resultList.add(strings[2]);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return resultList;
    }


    public ArrayList<String> getJobCallBaseOperate(String id1, String str) {
        ArrayList<String> resultList = new ArrayList<String>();
        try {
            String[] strings = str.split("_");
            JobCallComInfo comInfo = new JobCallComInfo();
            String sign = comInfo.getJobCallCheckbox(id1);
            resultList.add(strings[0]);
            if (strings[1].equals("true") && sign.equals("true")) {
                resultList.add("true");
            } else {
                resultList.add("false");
            }
            resultList.add(strings[2]);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return resultList;
    }


    public ArrayList<String> getUseKindBaseOperate(String id1, String str) {
        ArrayList<String> resultList = new ArrayList<String>();
        try {
            String[] strings = str.split("_");
            UseKindComInfo comInfo = new UseKindComInfo();
            String sign = comInfo.getUseKindCheckbox(id1);
            resultList.add(strings[0]);
            if (strings[1].equals("true") && sign.equals("true")) {
                resultList.add("true");
            } else {
                resultList.add("false");
            }
            resultList.add(strings[2]);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return resultList;
    }


    public String getJobGroupsname(String jobactivityid) {
        String jobGroupsname = "";
        try {
            JobActivitiesComInfo jComInfo = new JobActivitiesComInfo();
            if (Util.null2String(jobactivityid).length() == 0) return "";
            String jobgroupid = (String) jComInfo.getJobgroupid(jobactivityid);
            if (Util.null2String(jobgroupid).length() == 0) return "";
            JobGroupsComInfo JobGroupsComInfo = new JobGroupsComInfo();
            jobGroupsname = JobGroupsComInfo.getJobGroupsremarks(jobgroupid);
        } catch (Exception e) {
        }
        return jobGroupsname;
    }


    public static int getIntValue(Object obj) {
        String i = Util.null2String(obj);
        if (i.length() == 0) return 0;
        else return Integer.parseInt(i);
    }

    public static int getIntValue(Object obj, int def) {
        String i = Util.null2String(obj);
        if (i.length() == 0) return def;
        else return Integer.parseInt(i);
    }


    public static String getStringValue(Object obj, String def) {
        String i = Util.null2String(obj);
        if (i.length() == 0) return def;
        else return i;
    }


    public ArrayList<String> getSignatureOperate(String id, String str) {
        ArrayList<String> resultList = new ArrayList<String>();
        List parameterList = Util.TokenizerString(str, "+");
        int userid = Integer.parseInt((String) parameterList.get(1));
        String subcompanyid = (String) parameterList.get(0);
        String hrmdetachable = "0";
        ManageDetachComInfo ManageDetachComInfo = new ManageDetachComInfo();
        boolean isUseHrmManageDetach = ManageDetachComInfo.isUseHrmManageDetach();
        if (isUseHrmManageDetach) {
            hrmdetachable = "1";
        } else {
            hrmdetachable = "0";
        }
        int operatelevel = 0;
        CheckSubCompanyRight CheckSubCompanyRight = new CheckSubCompanyRight();
        if (!"1".equals(userid)) {
            if ("1".equals(hrmdetachable)) {
                operatelevel = CheckSubCompanyRight.ChkComRightByUserRightCompanyId(userid,
                        "SignatureAdd:Add", Util.getIntValue(subcompanyid, -1));
            } else {
                if (HrmUserVarify.checkUserRight("SignatureAdd:Add", new User(userid))) {
                    operatelevel = 2;
                }
            }
        } else {
            operatelevel = 2;
        }
        if (operatelevel > 0 && HrmUserVarify.checkUserRight("SignatureEdit:Edit", new User(userid))) {
            resultList.add("true");
            if (operatelevel > 1) {
                resultList.add("true");
            } else {
                resultList.add("false");
            }
        } else {
            resultList.add("false");
            resultList.add("false");
        }
        return resultList;
    }

    public String getSignaturegetCheckBoxDetach(String str) {
        List parameterList = Util.TokenizerString(str, "+");
        int userid = Integer.parseInt((String) parameterList.get(1));
        String subcompanyid = (String) parameterList.get(0);
        String hrmdetachable = "0";
        ManageDetachComInfo ManageDetachComInfo = new ManageDetachComInfo();
        boolean isUseHrmManageDetach = ManageDetachComInfo.isUseHrmManageDetach();
        if (isUseHrmManageDetach) {
            hrmdetachable = "1";
        } else {
            hrmdetachable = "0";
        }
        int operatelevel = 0;
        CheckSubCompanyRight CheckSubCompanyRight = new CheckSubCompanyRight();
        if (!"1".equals(userid)) {
            if ("1".equals(hrmdetachable)) {
                operatelevel = CheckSubCompanyRight.ChkComRightByUserRightCompanyId(userid,
                        "SignatureAdd:Add", Util.getIntValue(subcompanyid, -1));
            } else {
                if (HrmUserVarify.checkUserRight("SignatureAdd:Add", new User(userid))) {
                    operatelevel = 2;
                }
            }
        } else {
            operatelevel = 2;
        }
        if (operatelevel > 1 && HrmUserVarify.checkUserRight("SignatureEdit:Edit", new User(userid))) {
            return "true";
        }
        return "false";
    }


    @SuppressWarnings("deprecation")
    public ArrayList<String> getHrmOrgGroupOperate(String id1, String str) {
        ArrayList<String> resultList = new ArrayList<String>();
        try {
            CheckSubCompanyRight CheckSubCompanyRight = new CheckSubCompanyRight();
            List parameterList = Util.TokenizerString(str, "+");
            int subcomp = Util.getIntValue(parameterList.get(0).toString(), 0);
            int userid = Util.getIntValue(parameterList.get(1).toString(), 0);
            boolean hrmdetachable = "true".equals(parameterList.get(2).toString());
            String hasRight = parameterList.get(3).toString();
            int operatelevel = -1;
            if (hrmdetachable) {
                operatelevel = CheckSubCompanyRight.ChkComRightByUserRightCompanyId(userid, "GroupsSet:Maintenance", subcomp);
                if(operatelevel>0){
                    resultList.add(hasRight);
                    resultList.add(hasRight);
                }else{
                    resultList.add("false");
                    resultList.add("false");
                }
            }else{
                resultList.add(hasRight);
                resultList.add(hasRight);
            }
            RecordSet rs = new RecordSet();
            rs.executeSql("select 1 from HrmOrgGroupRelated where orgGroupId=" + id1);
            if (rs.next()) {
                resultList.add("false");
            } else if(hrmdetachable&&operatelevel > 1){   //开启了分权并完全控制，可以删除
                 resultList.add("true");
            } else if(hrmdetachable&&operatelevel <= 1){  //开启了分权不是完全控制，不允许删除
                resultList.add("false");
            } else {    //没有开启分权有权限得可以删除
                resultList.add(hasRight);
            }
            resultList.add(hasRight);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return resultList;
    }

    public String getRelatedName(String content, String otherpara) {
        String relatedName = "";
        String relatedType = "";
        String str[] = Util.TokenizerString2(otherpara, "+");
        if (str.length >= 1) {
            relatedType = str[0];
        }
        int languageid = Integer.parseInt(str[2]);
        try {
            SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
            DepartmentComInfo departmentComInfo = new DepartmentComInfo();
            if ("1".equals(relatedType)) {
                ResourceComInfo resourceComInfo = new ResourceComInfo();
                relatedName = resourceComInfo.getResourcename("" + content);

            } else if ("2".equals(relatedType)) {

                if (str[1].equals("1")) {
                    relatedName = subCompanyComInfo.getSubCompanyname(content) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")";
                } else {
                    relatedName = subCompanyComInfo.getSubCompanyname("" + content);
                }

            } else if ("3".equals(relatedType)) {

                if (str[1].equals("1")) {
                    relatedName = departmentComInfo.getDepartmentname(content) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")";
                } else {
                    relatedName = departmentComInfo.getDepartmentname(content);
                }
            } else if ("4".equals(relatedType)) {

                RolesComInfo rComInfo = new RolesComInfo();
                String st = (str[3].equals("2")) ? SystemEnv.getHtmlLabelName(124, languageid) : (str[3].equals("1") ? SystemEnv.getHtmlLabelName(141, languageid) : SystemEnv.getHtmlLabelName(140, languageid));
                relatedName = rComInfo.getRolesRemark(content) + "/" + st;
            } else if ("7".equals(relatedType)) {
                JobTitlesComInfo rComInfo = new JobTitlesComInfo();
                String st = "";
                if (str[3].equals("0")) st = "/" + SystemEnv.getHtmlLabelName(140, languageid);
                if (str[3].equals("1"))
                    st = "/" + SystemEnv.getHtmlLabelName(19437, languageid) + "(" + subCompanyComInfo.getSubCompanyname(str[4]) + ")";
                if (str[3].equals("2"))
                    st = "/" + SystemEnv.getHtmlLabelName(19438, languageid) + "(" + departmentComInfo.getDepartmentname(str[5]) + ")";
                relatedName = rComInfo.getJobTitlesname(content) + st;
            } else {
                relatedName = SystemEnv.getHtmlLabelName(1340, languageid);
            }
        } catch (Exception e) {
            // TODO: handle exception
            e.printStackTrace();
        }

        return relatedName;
    }


    public String getRelatedBaseOperate(String id, String str) {
        return str;
    }

    public String getRelatedSecLevel(String secLevelFrom, String secLevelTo) {
        if (secLevelFrom.equals("0") && secLevelTo.equals("0")) return "";
        String relatedSecLevel = "";
        relatedSecLevel = secLevelFrom + " - " + secLevelTo;
        return relatedSecLevel;
    }


    public static String getGroupShareTypeName(String sharetype, String language) {
        String name = "";
        try {
            if (sharetype.equals("1")) {
                name = SystemEnv.getHtmlLabelName(179, Util.getIntValue(language, 7));
            } else if (sharetype.equals("2")) {
                name = SystemEnv.getHtmlLabelName(141, Util.getIntValue(language, 7));
            } else if (sharetype.equals("3")) {
                name = SystemEnv.getHtmlLabelName(124, Util.getIntValue(language, 7));
            } else if (sharetype.equals("4")) {
                name = SystemEnv.getHtmlLabelName(122, Util.getIntValue(language, 7));
            } else if (sharetype.equals("7")) {
                name = SystemEnv.getHtmlLabelName(6086, Util.getIntValue(language, 7));
            } else if (sharetype.equals("5")) {
                name = SystemEnv.getHtmlLabelName(1340, Util.getIntValue(Util.getIntValue(language,7)));
            } else {
                name = SystemEnv.getHtmlLabelName(136, Util.getIntValue(language, 7));
            }
        } catch (Exception e) {
            new BaseBean().writeLog(e);
        }
        return name;
    }


    @SuppressWarnings("deprecation")
    public String getSysObjectName(String id, String otherpara) {
        String relatedName = "";
        String relatedType = "";
        String lowerlevel = "";
        RecordSet rs = new RecordSet();
        rs.executeSql("select * from HrmBirthdayShare where id =" + id + "");
        try {
            if (rs.next()) {
                relatedType = rs.getString("sharetype");
                lowerlevel = rs.getString("lowerlevel");

                int languageid = Integer.parseInt(otherpara);
                SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
                DepartmentComInfo departmentComInfo = new DepartmentComInfo();
                if ("1".equals(relatedType)) {
                    ResourceComInfo resourceComInfo = new ResourceComInfo();
                    relatedName = resourceComInfo.getResourcename(rs.getString("userid"));
                } else if ("2".equals(relatedType)) {

                    if (lowerlevel.equals("1")) {
                        relatedName = subCompanyComInfo.getSubCompanyname(rs.getString("subcompanyid")) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")";
                    } else {
                        relatedName = subCompanyComInfo.getSubCompanyname("" + rs.getString("subcompanyid"));
                    }

                } else if ("3".equals(relatedType)) {

                    if (lowerlevel.equals("1")) {
                        relatedName = departmentComInfo.getDepartmentname(rs.getString("departmentid")) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")";
                    } else {
                        relatedName = departmentComInfo.getDepartmentname(rs.getString("departmentid"));
                    }
                } else if ("4".equals(relatedType)) {

                    RolesComInfo rComInfo = new RolesComInfo();
                    String st = (rs.getString("rolelevel").equals("2")) ? SystemEnv.getHtmlLabelName(140, languageid) : (rs.getString("rolelevel").equals("1") ? SystemEnv.getHtmlLabelName(141, languageid) : SystemEnv.getHtmlLabelName(124, languageid));
                    relatedName = rComInfo.getRolesRemark(rs.getString("roleid")) + "/" + st;
                } else if ("7".equals(relatedType)) {
                    JobTitlesComInfo rComInfo = new JobTitlesComInfo();
                    String st = "";
                    if (rs.getString("jobtitlelevel").equals("0"))
                        st = "/" + SystemEnv.getHtmlLabelName(140, languageid);
                    if (rs.getString("jobtitlelevel").equals("1"))
                        st = "/" + SystemEnv.getHtmlLabelName(19437, languageid) + "(" + subCompanyComInfo.getSubCompanyname(rs.getString("jobsubcompany")) + ")";
                    if (rs.getString("jobtitlelevel").equals("2"))
                        st = "/" + SystemEnv.getHtmlLabelName(19438, languageid) + "(" + departmentComInfo.getDepartmentname(rs.getString("jobdepartment")) + ")";
                    relatedName = rComInfo.getJobTitlesname(rs.getString("jobtitleid")) + st;
                } else {
                    relatedName = SystemEnv.getHtmlLabelName(1340, languageid);
                }
            }
        } catch (Exception e) {
            // TODO: handle exception
            e.printStackTrace();
        }
        return relatedName;
    }

    /**
     * 合同到期提醒--获取提醒对象的名称
     *
     * @param id
     * @param otherpara
     * @return
     */
    public String getConRemindObjName(String id, String otherpara) {
        String relatedName = "";
        String relatedType = "";
        String lowerlevel = "";
        RecordSet rs = new RecordSet();
        rs.executeSql("select * from HrmContractShare where id =" + id + "");
        try {
            if (rs.next()) {
                relatedType = rs.getString("sharetype");
                lowerlevel = rs.getString("lowerlevel");

                int languageid = Integer.parseInt(otherpara);
                SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
                DepartmentComInfo departmentComInfo = new DepartmentComInfo();
                if ("1".equals(relatedType)) {
                    ResourceComInfo resourceComInfo = new ResourceComInfo();
                    relatedName = resourceComInfo.getResourcename(rs.getString("userid"));
                } else if ("2".equals(relatedType)) {

                    if (lowerlevel.equals("1")) {
                        relatedName = subCompanyComInfo.getSubCompanyname(rs.getString("subcompanyid")) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")";
                    } else {
                        relatedName = subCompanyComInfo.getSubCompanyname("" + rs.getString("subcompanyid"));
                    }

                } else if ("3".equals(relatedType)) {

                    if (lowerlevel.equals("1")) {
                        relatedName = departmentComInfo.getDepartmentname(rs.getString("departmentid")) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")";
                    } else {
                        relatedName = departmentComInfo.getDepartmentname(rs.getString("departmentid"));
                    }
                } else if ("4".equals(relatedType)) {

                    RolesComInfo rComInfo = new RolesComInfo();
                    String st = (rs.getString("rolelevel").equals("2")) ? SystemEnv.getHtmlLabelName(140, languageid) : (rs.getString("rolelevel").equals("1") ? SystemEnv.getHtmlLabelName(141, languageid) : SystemEnv.getHtmlLabelName(124, languageid));
                    relatedName = rComInfo.getRolesRemark(rs.getString("roleid")) + "/" + st;
                } else if ("7".equals(relatedType)) {
                    JobTitlesComInfo rComInfo = new JobTitlesComInfo();
                    String st = "";
                    if (rs.getString("jobtitlelevel").equals("0"))
                        st = "/" + SystemEnv.getHtmlLabelName(140, languageid);
                    if (rs.getString("jobtitlelevel").equals("1"))
                        st = "/" + SystemEnv.getHtmlLabelName(19437, languageid) + "(" + subCompanyComInfo.getSubCompanyname(rs.getString("jobsubcompany")) + ")";
                    if (rs.getString("jobtitlelevel").equals("2"))
                        st = "/" + SystemEnv.getHtmlLabelName(19438, languageid) + "(" + departmentComInfo.getDepartmentname(rs.getString("jobdepartment")) + ")";
                    relatedName = rComInfo.getJobTitlesname(rs.getString("jobtitleid")) + st;
                } else {
                    relatedName = SystemEnv.getHtmlLabelName(1340, languageid);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return relatedName;
    }


    public static String getRemindLevelName(String sharetype, String language) {
        String name = "";
        try {
            if (sharetype.equals("0")) {
                name = SystemEnv.getHtmlLabelName(18511, Util.getIntValue(language, 7));
            } else if (sharetype.equals("1")) {
                name = SystemEnv.getHtmlLabelName(125671, Util.getIntValue(language, 7));
            } else if (sharetype.equals("2")) {
                name = SystemEnv.getHtmlLabelName(125591, Util.getIntValue(language, 7));
            } else if (sharetype.equals("3")) {
                name = SystemEnv.getHtmlLabelName(18512, Util.getIntValue(language, 7));
            } else if (sharetype.equals("4")) {
                name = SystemEnv.getHtmlLabelName(382944, Util.getIntValue(language, 7));
            } else if (sharetype.equals("5")) {
                name = SystemEnv.getHtmlLabelName(82790, Util.getIntValue(language, 7));
            } else if (sharetype.equals("6")) {
                name = SystemEnv.getHtmlLabelName(1340, Util.getIntValue(language, 7));
            }
        } catch (Exception e) {
            new BaseBean().writeLog(e);
        }
        return name;
    }

    public String getAllParentsOrg(String id) {
        boolean isVirtual = false;
        if (Util.getIntValue(id) < 0) {
            isVirtual = true;
        }
        String supsubcomid = "";
        if (isVirtual) {
            SubCompanyVirtualComInfo subVirComInfo = new SubCompanyVirtualComInfo();
            supsubcomid = Util.null2String(subVirComInfo.getSupsubcomid(id));
        } else {
            SubCompanyComInfo subComInfo = new SubCompanyComInfo();
            supsubcomid = Util.null2String(subComInfo.getSupsubcomid(id));
        }
        String pname = getPName("", supsubcomid, isVirtual);
        return pname;
    }

    private String getPName(String pname, String id, boolean isVirtual) {
        if ("0".equals(id) || "".equals(id)) return pname;
        String _pname = "";
        String _pid = "";
        if (isVirtual) {
            SubCompanyVirtualComInfo subVirComInfo = new SubCompanyVirtualComInfo();
            _pname = subVirComInfo.getSubCompanyname(id);
            _pid = Util.null2String(subVirComInfo.getSupsubcomid(id));
        } else {
            SubCompanyComInfo subComInfo = new SubCompanyComInfo();
            _pname = subComInfo.getSubCompanyname(id);
            _pid = Util.null2String(subComInfo.getSupsubcomid(id));
        }
        pname = ("".equals(pname) ? "" : pname + "/") + _pname;
        return getPName(pname, _pid, isVirtual);
    }

    public String getRightSubComLevel(String rightlevel, String language) {
        String rightSubComLevel = "";
        if (rightlevel.length() == 0) return rightSubComLevel;
        switch (Util.getIntValue(rightlevel)) {
            case -1:
                rightSubComLevel = SystemEnv.getHtmlLabelName(17875, Util.getIntValue(language, 7));
                break;
            case 0:
                rightSubComLevel = SystemEnv.getHtmlLabelName(17873, Util.getIntValue(language, 7));
                break;
            case 1:
                rightSubComLevel = SystemEnv.getHtmlLabelName(93, Util.getIntValue(language, 7));
                break;
            case 2:
                rightSubComLevel = SystemEnv.getHtmlLabelName(17874, Util.getIntValue(language, 7));
                break;
            default:
                break;
        }
        return rightSubComLevel;
    }

    public String getResourceType(String resourcetype, String language) {
        String result = "";
        if (resourcetype.length() == 0) return result;
        switch (Util.getIntValue(resourcetype)) {
            case 1:
                result = SystemEnv.getHtmlLabelName(179, Util.getIntValue(language, 7));
                break;
            case 2:
                result = SystemEnv.getHtmlLabelName(141, Util.getIntValue(language, 7));
                break;
            case 3:
                result = SystemEnv.getHtmlLabelName(124, Util.getIntValue(language, 7));
                break;
            case 5:
                result = SystemEnv.getHtmlLabelName(6086, Util.getIntValue(language, 7));
                break;
            case 6:
                result = SystemEnv.getHtmlLabelName(1340, Util.getIntValue(language, 7));
                break;
            case 7:
                result = SystemEnv.getHtmlLabelName(1507, Util.getIntValue(language, 7));
                break;
            case 8:
                result = SystemEnv.getHtmlLabelName(16139, Util.getIntValue(language, 7));
                break;
            case 10:
                result = "职务";
                break;
            default:
                break;
        }
        return result;
    }

    public String getResourceName(String resourceid, String otherpara) {
        String result = "";
        String str[] = Util.splitString(otherpara, "+");
        String resourcetype = str[0];
        String alllevel = str[1];
        int languageid = Util.getIntValue(str[2]);
        String jobtitlelevel = str[3];
        String subdepid = str[4];
        try {
            SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
            DepartmentComInfo departmentComInfo = new DepartmentComInfo();
            if ("1".equals(resourcetype) || "7".equals(resourcetype) || "8".equals(resourcetype)) {
                ResourceComInfo resourceComInfo = new ResourceComInfo();
                result = resourceComInfo.getResourcename(resourceid);
            } else if ("2".equals(resourcetype)) {
                if (alllevel.equals("1")) {
                    result = subCompanyComInfo.getSubCompanyname(resourceid) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")";
                } else {
                    result = subCompanyComInfo.getSubCompanyname(resourceid);
                }
            } else if ("3".equals(resourcetype)) {
                if (alllevel.equals("1")) {
                    result = departmentComInfo.getDepartmentname(resourceid) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")";
                } else {
                    result = departmentComInfo.getDepartmentname(resourceid);
                }
            } else if ("5".equals(resourcetype)) {
                JobTitlesComInfo rComInfo = new JobTitlesComInfo();
                String st = "";
                if (jobtitlelevel.equals("1")) st = "/" + SystemEnv.getHtmlLabelName(140, languageid);
                if (jobtitlelevel.equals("2"))
                    st = "/" + SystemEnv.getHtmlLabelName(19437, languageid) + "(" + subCompanyComInfo.getSubcompanynames(subdepid) + ")";
                if (jobtitlelevel.equals("3"))
                    st = "/" + SystemEnv.getHtmlLabelName(19438, languageid) + "(" + departmentComInfo.getDepartmentNames(subdepid) + ")";
                result = rComInfo.getJobTitlesname(resourceid) + st;
            } else if ("6".equals(resourcetype)) {
                result = SystemEnv.getHtmlLabelName(1340, languageid);
            } else if ("10".equals(resourcetype)){
                result = findJobGroupName(resourceid);
            }
        } catch (Exception e) {
            writeLog(e);
        }
        return result;
    }

    public String findJobGroupName(String resourceid){
        RecordSet rs = new RecordSet();
        String jobgroupremark = "";
        String sql = "select jobgroupremark  from hrmjobgroups where id = "+resourceid;
        rs.executeQuery(sql);
        if(rs.next()){
            jobgroupremark = Util.null2String(rs.getString("jobgroupremark"));
        }
        return jobgroupremark;
    }

//  角色成员列表中名称的trans方法
    public String getResourceNameRole(String resourceid, String otherpara) {
        String result = "";
        String str[] = Util.splitString(otherpara, "+");
        String resourcetype = str[0];
        String alllevel = str[1];
        int languageid = Util.getIntValue(str[2]);
        String jobtitlelevel = str[3];
        String subdepid = str[4];
        try {
            SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
            DepartmentComInfo departmentComInfo = new DepartmentComInfo();
            if ("1".equals(resourcetype) || "7".equals(resourcetype) || "8".equals(resourcetype)) {
                ResourceComInfo resourceComInfo = new ResourceComInfo();
                result = "<a href=\"javascript:openhrm(" + resourceid + ")\" onclick=\"pointerXY(event);\" >"
                        + resourceComInfo.getResourcename(resourceid) + "</a>";
            } else if ("2".equals(resourcetype)) {
                if (alllevel.equals("1")) {
                    result = "<a href='/spa/hrm/engine.html#/hrmengine/organization?showTree=false&type=subcompany&id=" + resourceid + "' target='_blank'>" +  subCompanyComInfo.getSubCompanyname(resourceid) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")" + "</a>";
                } else {
                    result = "<a href='/spa/hrm/engine.html#/hrmengine/organization?showTree=false&type=subcompany&id=" + resourceid + "' target='_blank'>" +  subCompanyComInfo.getSubCompanyname(resourceid) + "</a>";
                }
            } else if ("3".equals(resourcetype)) {
                if (alllevel.equals("1")) {
                    result = "<a href='/spa/hrm/engine.html#/hrmengine/organization?showTree=false&type=department&id=" + resourceid + "' target='_blank'>" + departmentComInfo.getDepartmentname(resourceid) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")" + "</a>";
                } else {
                    result = "<a href='/spa/hrm/engine.html#/hrmengine/organization?showTree=false&type=department&id=" + resourceid + "' target='_blank'>" + departmentComInfo.getDepartmentname(resourceid) + "</a>";
                }
            } else if ("5".equals(resourcetype)) {
                JobTitlesComInfo rComInfo = new JobTitlesComInfo();
                String st = "";
                if (jobtitlelevel.equals("1")) st = "/" + SystemEnv.getHtmlLabelName(140, languageid);
                if (jobtitlelevel.equals("2"))
                    st = "/" + SystemEnv.getHtmlLabelName(19437, languageid) + "(" + subCompanyComInfo.getSubCompanyname(subdepid) + ")";
                if (jobtitlelevel.equals("3"))
                    st = "/" + SystemEnv.getHtmlLabelName(19438, languageid) + "(" + departmentComInfo.getDepartmentname(subdepid) + ")";
                result = "<a href='/spa/hrm/engine.html#/hrmengine/posts?id=" + resourceid + "' target='_blank'>" +rComInfo.getJobTitlesname(resourceid) + st + "</a>";
            } else if ("6".equals(resourcetype)) {
                result = SystemEnv.getHtmlLabelName(1340, languageid);
            }
        } catch (Exception e) {
            writeLog(e);
        }
        return result;
    }




    public String getSecLevel(String secLevelFrom, String secLevelTo) {
        String result = "";
        secLevelFrom = Util.null2String(secLevelFrom).trim();
        secLevelTo = Util.null2String(secLevelTo).trim();
        if (secLevelFrom.equals("") && secLevelTo.equals("")) return "";
        if (secLevelFrom.equals("0") && secLevelTo.equals("0")) return "";
        result = secLevelFrom + " - " + secLevelTo;
        return result;
    }

    public String getRoleLevel(String roleLevel, String language) {
        String result = "";
        if (roleLevel.length() == 0) return result;
        switch (Util.getIntValue(roleLevel)) {
            case 0:
                result = SystemEnv.getHtmlLabelName(124, Util.getIntValue(language, 7));
                break;
            case 1:
                result = SystemEnv.getHtmlLabelName(141, Util.getIntValue(language, 7));
                break;
            case 2:
                result = SystemEnv.getHtmlLabelName(140, Util.getIntValue(language, 7));
                break;
            default:
                break;
        }
        return result;
    }


    @SuppressWarnings("deprecation")
    public String getSysObjectName2(String id, String otherpara) {
        String relatedName = "";
        String relatedType = "";
        String lowerlevel = "";
        RecordSet rs = new RecordSet();
        rs.executeSql("select * from HrmContractShare where id =" + id + "");
        try {
            if (rs.next()) {
                relatedType = rs.getString("sharetype");
                lowerlevel = rs.getString("lowerlevel");
                int languageid = Integer.parseInt(otherpara);
                SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
                DepartmentComInfo departmentComInfo = new DepartmentComInfo();
                if ("1".equals(relatedType)) {
                    ResourceComInfo resourceComInfo = new ResourceComInfo();
                    relatedName = resourceComInfo.getResourcename(rs.getString("userid"));
                } else if ("2".equals(relatedType)) {
                    if (lowerlevel.equals("1")) {
                        relatedName = subCompanyComInfo.getSubCompanyname(rs.getString("subcompanyid")) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")";
                    } else {
                        relatedName = subCompanyComInfo.getSubCompanyname("" + rs.getString("subcompanyid"));
                    }
                } else if ("3".equals(relatedType)) {
                    if (lowerlevel.equals("1")) {
                        relatedName = departmentComInfo.getDepartmentname(rs.getString("departmentid")) + "(" + SystemEnv.getHtmlLabelName(125963, languageid) + ")";
                    } else {
                        relatedName = departmentComInfo.getDepartmentname(rs.getString("departmentid"));
                    }
                } else if ("4".equals(relatedType)) {
                    RolesComInfo rComInfo = new RolesComInfo();
                    String st = (rs.getString("rolelevel").equals("2")) ? SystemEnv.getHtmlLabelName(140, languageid) : (rs.getString("rolelevel").equals("1") ? SystemEnv.getHtmlLabelName(141, languageid) : SystemEnv.getHtmlLabelName(124, languageid));
                    relatedName = rComInfo.getRolesRemark(rs.getString("roleid")) + "/" + st;
                } else if ("7".equals(relatedType)) {
                    JobTitlesComInfo rComInfo = new JobTitlesComInfo();
                    String st = "";
                    if (rs.getString("jobtitlelevel").equals("0"))
                        st = "/" + SystemEnv.getHtmlLabelName(140, languageid);
                    if (rs.getString("jobtitlelevel").equals("1"))
                        st = "/" + SystemEnv.getHtmlLabelName(19437, languageid) + "(" + subCompanyComInfo.getSubCompanyname(rs.getString("jobsubcompany")) + ")";
                    if (rs.getString("jobtitlelevel").equals("2"))
                        st = "/" + SystemEnv.getHtmlLabelName(19438, languageid) + "(" + departmentComInfo.getDepartmentname(rs.getString("jobdepartment")) + ")";
                    relatedName = rComInfo.getJobTitlesname(rs.getString("jobtitleid")) + st;
                } else {
                    relatedName = SystemEnv.getHtmlLabelName(1340, languageid);
                }
            }
        } catch (Exception e) {
            // TODO: handle exception
            e.printStackTrace();
        }
        return relatedName;
    }

    public String getModuleManageDetachType(String unused, String roleid, String language) {
        BaseBean bb = new BaseBean();
        try {
            int iRoleid = Util.getIntValue(roleid, 0);
            if (iRoleid != 0) {
                if (iRoleid > 0) {
                    return SystemEnv.getHtmlLabelName(122, Util.getIntValue(language, 7));//122 角色
                } else {
                    return SystemEnv.getHtmlLabelName(1867, Util.getIntValue(language, 7));//1867 人员
                }
            }
        } catch (Exception ex) {
            bb.writeLog(ex);
        }
        return "";
    }


    @SuppressWarnings("deprecation")
    public String getModuleManageDetachAdmin(String unused, String roleid, String language) {
        String temp = language;
        language = roleid;
        roleid = temp;
        BaseBean bb = new BaseBean();
        try {
            int iRoleid = Util.getIntValue(roleid, 0);
            if (iRoleid != 0) {
                StringBuffer _names = new StringBuffer();
                RecordSet rs = new RecordSet();
                String sql = "";
                if (iRoleid > 0) {
                    sql = "select distinct aa.rolesmark AS name from HrmRoles aa where aa.id = '" + iRoleid + "' ";
                } else {
                    sql = "select distinct bb.lastname as name from hrmrolemembers aa " +
                            " join HrmResource bb on aa.resourceid = bb.id " +
                            " where aa.roleid = '" + iRoleid + "' ";
                }
                rs.executeSql(sql);
                while (rs.next()) {
                    String _name = Util.null2String(rs.getString("name")).trim();
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(_name);
                }
                return _names.toString();
            }
        } catch (Exception ex) {
            bb.writeLog(ex);
        }
        return "";
    }

    //用于 模块管理分权  组织机构
    @SuppressWarnings("deprecation")
    public String getModuleManageDetachOrg(String unused, String roleid, String language) {
        String temp = language;
        language = roleid;
        roleid = temp;
        BaseBean bb = new BaseBean();
        try {
            int iRoleid = Util.getIntValue(roleid, 0);
            if (iRoleid != 0) {
                StringBuffer _names = new StringBuffer();
                RecordSet rs = new RecordSet();
                String sql = "select bb.subcompanyname \n" +
                        " from SysRoleSubcomRight aa \n" +
                        " join HrmSubCompany bb on aa.subcompanyid = bb.id \n" +
                        " where aa.roleid = " + iRoleid;
                rs.executeSql(sql);
                while (rs.next()) {
                    String _name = Util.null2String(rs.getString("subcompanyname")).trim();
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(_name);
                }
                return _names.toString();
            }
        } catch (Exception ex) {
            bb.writeLog(ex);
        }
        return "";
    }


    /**
     * 用于 模块管理分权
     *
     * @param roleid
     * @param language
     * @return
     */
    @SuppressWarnings({"rawtypes", "unchecked", "deprecation"})
    public String getModuleManageDetachMod(String unused, String roleid, String language) {
        String temp = language;
        language = roleid;
        roleid = temp;
        BaseBean bb = new BaseBean();
        try {
            int iRoleid = Util.getIntValue(roleid, 0);
            if (iRoleid != 0) {
                StringBuffer _names = new StringBuffer();
                List rightidList = new ArrayList();
                RecordSet rs = new RecordSet();
                String sql = "select aa.rightid from SystemRightRoles aa where aa.roleid = " + iRoleid;
                rs.executeSql(sql);
                while (rs.next()) {
                    String rightid = Util.getIntValue(rs.getString("rightid")) + "";
                    rightidList.add(rightid);
                }
                String[] hrmrights = {"18", "19", "22", "25", "30", "35", "37", "109", "381", "381", "395", "587",
                        "588", "657", "658", "660", "661", "664", "787", "788", "789", "906", "907",
                        "908", "1827", "1849", "1850", "1851", "1918", "1919"};

                String[] wfrights = {"91", "300", "591", "719", "771", "837", "838", "1749", "1836"};
                String[] docrights = {"1", "4", "8", "10", "11", "16", "453", "690", "1535", "2086"};
                String[] portalrights = {"599", "644", "645", "659"};
                String[] cptrights = {"439","137"};
                String[] mtirights = {"200", "350"};
                String[] fmrights = {"1297", "1796", "1797"};
                String[] mmrights = {"1727"};
                String[] carsrights = {"463"};
                String[] odocsrights = {"2471"};

                if (rightidList.containsAll(Arrays.asList(hrmrights))) {
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(SystemEnv.getHtmlLabelName(179, Util.getIntValue(language, 7)));//人力资源
                }
                if (rightidList.containsAll(Arrays.asList(wfrights))) {
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(SystemEnv.getHtmlLabelName(2118, Util.getIntValue(language, 7)));//工作流程
                }
                if (rightidList.containsAll(Arrays.asList(docrights))) {
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(SystemEnv.getHtmlLabelName(2115, Util.getIntValue(language, 7)));//知识管理
                }
                if (rightidList.containsAll(Arrays.asList(portalrights))) {
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(SystemEnv.getHtmlLabelName(20613, Util.getIntValue(language, 7)));//门户管理
                }
                if (rightidList.containsAll(Arrays.asList(cptrights))) {
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(SystemEnv.getHtmlLabelName(2116, Util.getIntValue(language, 7)));//资产管理
                }
                if (rightidList.containsAll(Arrays.asList(mtirights))) {
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(SystemEnv.getHtmlLabelName(18442, Util.getIntValue(Util.getIntValue(language,7))));//会议管理
                }
                if (rightidList.containsAll(Arrays.asList(fmrights))) {
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(SystemEnv.getHtmlLabelName(30235, Util.getIntValue(language, 7)));//表单建模
                }
                if (rightidList.containsAll(Arrays.asList(mmrights))) {
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(SystemEnv.getHtmlLabelName(81788, Util.getIntValue(language, 7)));//移动建模
                }
                if (rightidList.containsAll(Arrays.asList(carsrights))) {
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(SystemEnv.getHtmlLabelName(17629, Util.getIntValue(language, 7)));//车辆管理
                }
                if (rightidList.containsAll(Arrays.asList(odocsrights))) {
                    if (_names.length() > 0) {
                        _names.append(", ");
                    }
                    _names.append(SystemEnv.getHtmlLabelName(27618, Util.getIntValue(language, 7)));//公文管理
                }
                return _names.toString();
            }
        } catch (Exception ex) {
            bb.writeLog(ex);
        }
        return "";
    }

    public String getImportOperateTypeName(String type, String lauid) {
        int languageid = Integer.parseInt(lauid);
        String str = "";
        if (type.equals("add")) {
            str = SystemEnv.getHtmlLabelName(611, languageid);
        } else if (type.equals("update")) {
            str = SystemEnv.getHtmlLabelName(17744, languageid);
        } else if (type.equals("import")) {
            str = SystemEnv.getHtmlLabelName(18596, languageid);
        } else if (type.equals("cover")) {
            str = SystemEnv.getHtmlLabelName(31260, languageid);
        }
        return str;
    }

    public String getImportTypeName(String type, String lauid) {
        int languageid = Integer.parseInt(lauid);
        String str = "";
        if (type.equals("resource")) {
            str = SystemEnv.getHtmlLabelName(17887, languageid);
        } else if (type.equals("company")) {
            str = SystemEnv.getHtmlLabelName(125432, languageid);
        } else if (type.equals("jobtitle")) {
            str = SystemEnv.getHtmlLabelName(125443, languageid);
        } else if (type.equals("group")) {
            str = SystemEnv.getHtmlLabelName(125445, languageid);
        } else if (type.equals("resourcedetial")) {
            str = SystemEnv.getHtmlLabelName(125678, languageid);
        } else if (type.equals("city")) {
            str = SystemEnv.getHtmlLabelName(125450, languageid);
        } else if (type.equals("location")) {
            str = SystemEnv.getHtmlLabelName(125447, languageid);
        } else if (type.equals("special")) {
            str = SystemEnv.getHtmlLabelName(125449, languageid);
        } else if (type.equals("area")) {
            str = SystemEnv.getHtmlLabelName(126168, languageid);
        } else if (type.equals("matrix")) {
            str = SystemEnv.getHtmlLabelName(34066, languageid);
        } else if (type.equals("photo")) {
            str = SystemEnv.getHtmlLabelName(10000676, Util.getIntValue(languageid));
        } else if (type.equals("holidaySet")) {
            str = SystemEnv.getHtmlLabelName(385539, Util.getIntValue(languageid));
        } else if (type.equals("balanceOfLeave")) {
            str = SystemEnv.getHtmlLabelName(389441, Util.getIntValue(languageid));
        } else if (type.equals("sensitiveword")) {
            str = SystemEnv.getHtmlLabelName(531439, Util.getIntValue(languageid));
        }
        return str;
    }

    public static List<Map<String, Object>> getHrmBrowserValue(String hrmid) {
        List<Map<String, Object>> replaceDatas = new ArrayList<Map<String, Object>>();
        if (hrmid.length() == 0) return replaceDatas;
        Map<String, Object> datas = null;
        try {
            ResourceComInfo ComInfo = new ResourceComInfo();
            String name = "";
            String[] st = hrmid.split(",");
            for (int i = 0; i < st.length; i++) {
                datas = new HashMap<String, Object>();
                name = ComInfo.getLastname(st[i]);
                datas.put("id", st[i]);
                datas.put("name", name);
                replaceDatas.add(datas);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return replaceDatas;
    }

    /**
     * 获取签章类型名
     *
     * @param sealType     签章类型
     * @param userLanguage
     * @return
     */
    public String getSealType(String sealType, String userLanguage) {
        Integer type = Util.getIntValue(Util.null2String(sealType));
        String returnstr = null;
        switch (type) {
            case 1:
                // 个人签章
                returnstr = SystemEnv.getHtmlLabelName(127439, Util.getIntValue(userLanguage));
                break;
            case 2:
                // 公司签章
                returnstr = SystemEnv.getHtmlLabelName(127438, Util.getIntValue(userLanguage));
                break;
            default:
                // 未知签章类型
                returnstr = SystemEnv.getHtmlLabelName(127440, Util.getIntValue(userLanguage));
                break;
        }
        return returnstr;
    }

    /**
     * 获取是否默认签章
     *
     * @param sealType     签章类型
     * @param userLanguage
     * @return
     */
    public String isPersonalDefault(String isDefault, String param) {
        String[] tempStr = Util.splitString(param, "+");
        String userLanguage = tempStr[0];
        Integer type = Util.getIntValue(Util.null2String(tempStr[1]));
        String returnstr = null;
        //个人签章
        if (type == 1) {
            //默认个人签章
            if ("1".equals(isDefault)) {
                // 是
                returnstr = SystemEnv.getHtmlLabelName(163, Util.getIntValue(userLanguage));
            } else {
                // 否
                returnstr = SystemEnv.getHtmlLabelName(161, Util.getIntValue(userLanguage));
            }
        } else {
            // 空
            returnstr = "";
        }
        return returnstr;
    }

    public String getHrmRolesA(String name, String id) {
        return "<a href='/spa/hrm/engine.html#/hrmengine/roleInfo/info?id=" + id + "' target='_blank'>" + name + "</a>";
    }

    public String getHrmRolesC(String name, String otherParams) {
        String[] tempStr = Util.splitString(otherParams, "+");
        return "<a href='/spa/hrm/engine.html#/hrmengine/roleInfo/auth?id=" + tempStr[0] + "' target='_blank'>" + name + "</a>";
    }

    public String getHrmRolesD(String name, String otherParams) {
        String[] tempStr = Util.splitString(otherParams, "+");
        return "<a href='/spa/hrm/engine.html#/hrmengine/roleInfo/member?id=" + tempStr[0] + "' target='_blank'>" + SystemEnv.getHtmlLabelName(367, Util.getIntValue(tempStr[2], 7)) + "</a>";
    }

    public String getLastName(String id) {
        ResourceComInfo resourceComInfo = null;
        try {
            resourceComInfo = new ResourceComInfo();
        } catch (Exception e) {
            writeLog(e);
        }
        return "<a href='/spa/hrm/index_mobx.html#/main/hrm/card/cardInfo/" + id + "' target='_blank'>" + resourceComInfo.getLastname(id) + "</a>";
    }

    public String getSubCompanyName(String id) {
        SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
        return "<a href='/spa/hrm/engine.html#/hrmengine/organization?showTree=false&type=subcompany&id=" + id + "' target='_blank'>" + subCompanyComInfo.getSubCompanyname(id) + "</a>";
    }

    public String getDepartmentMark(String id) {
        DepartmentComInfo departmentComInfo = new DepartmentComInfo();
        return "<a href='/spa/hrm/engine.html#/hrmengine/organization?showTree=false&type=department&id=" + id + "' target='_blank'>" + departmentComInfo.getDepartmentmark(id) + "</a>";
    }

    public String getDepartmentName(String id) {
        DepartmentComInfo departmentComInfo = new DepartmentComInfo();
        return "<a href='/spa/hrm/engine.html#/hrmengine/organization?showTree=false&type=department&id=" + id + "' target='_blank'>" + departmentComInfo.getDepartmentname(id) + "</a>";
    }

    public String getJobTitleName(String id) {
        JobTitlesComInfo jobTitlesComInfo = new JobTitlesComInfo();
        return "<a href='/spa/hrm/engine.html#/hrmengine/singlePost?id=" + id + "' target='_blank'>" + jobTitlesComInfo.getJobTitlesname(id) + "</a>";
    }


    /**
     * 虚拟组织结构部门
     *
     * @param id
     * @param canEdit
     * @param otherPara
     * @return
     */
    public ArrayList<String> getDepartmentVirtualOperate(String id, String canEdit, String otherPara) {
        ArrayList<String> resultList = new ArrayList<String>();
        HrmOrganizationVirtualUtil hrmOrganizationUtil = new HrmOrganizationVirtualUtil();
        String canDel = otherPara.split(":")[0];
        String log = otherPara.split(":")[1];

        //编辑
        if (canEdit.equals("true")) {
            resultList.add("true");
        } else {
            resultList.add("false");
        }

        //封存
        if (canEdit.equals("true")) {
            resultList.add(String.valueOf(hrmOrganizationUtil.canCancelDepartment(Util.getIntValue(id))));
        } else {
            resultList.add("false");
        }

        //解封
        if (canEdit.equals("true")) {
            resultList.add(String.valueOf(hrmOrganizationUtil.canISCanceledDepartment(Util.getIntValue(id))));
        } else {
            resultList.add("false");
        }

        //删除
        if (canDel.equals("true")) {
            resultList.add(String.valueOf(hrmOrganizationUtil.canDelDepartment(Util.getIntValue(id))));
        } else {
            resultList.add("false");
        }

        //日志
        if (log.equals("true")) {
            resultList.add("true");
        } else {
            resultList.add("false");
        }

        return resultList;
    }

    public String getItemTypeName(String itemType, String userLanguage) {
        String itemTypeName = "";
        if ("1".equals(itemType)) {
            itemTypeName = SystemEnv.getHtmlLabelName(1804, Util.getIntValue(userLanguage, 7));
        } else if ("2".equals(itemType)) {
            itemTypeName = SystemEnv.getHtmlLabelName(15825, Util.getIntValue(userLanguage, 7));
        } else if ("3".equals(itemType)) {
            itemTypeName = SystemEnv.getHtmlLabelName(15826, Util.getIntValue(userLanguage, 7));
        } else if ("4".equals(itemType)) {
            itemTypeName = SystemEnv.getHtmlLabelName(449, Util.getIntValue(userLanguage, 7));
        }
        return itemTypeName;
    }

    public String getImportStatuaName(String status, String userLanguage) {
        String importStatuaName = "";
//		if("0".equals(status)){
//			importStatuaName = SystemEnv.getHtmlLabelName(128220, Util.getIntValue(userLanguage, 7));
//		}else if("1".equals(status)){
//			importStatuaName = SystemEnv.getHtmlLabelName(15242, Util.getIntValue(userLanguage, 7));
//		}
        return importStatuaName;
    }

    public String getWorkYear(String workStartDate) {
        String workyear = "0.0";
        Calendar today = Calendar.getInstance();
        String currentyear = Util.add0(today.get(Calendar.YEAR), 4);
        String tempyear = currentyear;
        if (Tools.isNotNull(workStartDate)) {
            String[] currentDate = Tools.getCurrentDate().split("-");
            if (currentDate[0].compareTo(tempyear) > 0) {
                currentDate[1] = "12";
                currentDate[2] = "31";
            }
            double _wy = Tools.round(Tools.compDate(workStartDate, tempyear + "-" + currentDate[1] + "-" + currentDate[2]) / 365, 1);
            if (_wy < 0) {
                _wy = 0;
            }
            workyear = String.valueOf(_wy);
        }
        return workyear;
    }

    public String formatdays(String days) {
        return "" + Util.getFloatValue(Util.round(Util.null2String(days), 2), 0);
    }


    /**
     * 虚拟组织结构部门
     *
     * @param id
     * @param canEdit
     * @param otherPara
     * @return
     */
    public ArrayList<String> getUnitOperate(String id, String otherPara) {
        ArrayList<String> resultList = new ArrayList<String>();
        String canEdit = otherPara.split(":")[0];
        String canDel = otherPara.split(":")[1];
        String showLog = otherPara.split(":")[2];

        //编辑
        if (canEdit.equals("true")) {
            resultList.add("true");
        } else {
            resultList.add("false");
        }

        //删除
        if (canDel.equals("true")) {
            resultList.add(getUnitCheckbox(id));
        } else {
            resultList.add("false");
        }

        //日志
        if (showLog.equals("true")) {
            resultList.add("true");
        } else {
            resultList.add("false");
        }

        return resultList;
    }

    public String getCodesettingreservedCheckbox(String id) {
        return "true";
    }

    public String getUnitCheckbox(String id) {
        String result = "true";
        RecordSet rs = new RecordSet();
        String sql = "";

        sql = "select count(1) from LgcAsset where assetunitid=" + id;
        rs.executeSql(sql);
        if (rs.next()) {
            if (rs.getInt(1) > 0) {
                result = "false";
            }
        }

        if (result.equals("true")) {
            sql = "select count(1) from CptCapital where unitid=" + id;
            rs.executeSql(sql);
            if (rs.next()) {
                if (rs.getInt(1) > 0) {
                    result = "false";
                }
            }
        }
        return result;
    }

    public String getScheduleShiftsSetField003Name(String id, String otherParams) {
        String name = "";
        String[] params = Util.splitString(otherParams, "+");
        String field004 = params[0];
        String field005 = params[1];
        int languageid = Util.getIntValue(params[2]);
        switch (StringUtil.parseToInt(id)) {
            case 1:
                name = SystemEnv.getHtmlLabelName(125828, languageid);
                break;
            case 2:
                name = SystemEnv.getHtmlLabelName(125823, languageid);
                break;
            case 3:
                name = SystemEnv.getHtmlLabelName(125824, languageid);
                break;
            case 4:
                name = SystemEnv.getHtmlLabelName(125825, languageid);
                break;
            case 5:
                name = SystemEnv.getHtmlLabelName(125826, languageid);
                break;
            case 6:
                name = SystemEnv.getHtmlLabelName(19516, languageid);
                int w = StringUtil.parseToInt(field004, 0);
                w = w < 0 ? 0 : w;
                int x = StringUtil.parseToInt(field005, 0);
                x = x < 0 ? 0 : x;
                name += "(" + SystemEnv.getHtmlLabelName(125900, languageid) + w + SystemEnv.getHtmlLabelName(125806, languageid) + x + ")";
                break;
            default:
                name = SystemEnv.getHtmlLabelName(125827, languageid);
                break;
        }
        return name;
    }

    public String getScheduleShiftsSetField006Name(String type, String otherParams) {
        int languageid = Util.getIntValue(otherParams);
        String name = SystemEnv.getHtmlLabelName(125837, languageid);
        if (Util.null2String(type).equals("1")) {
            name = SystemEnv.getHtmlLabelName(125899, languageid);
        }
        return name;
    }


    public String getScheduleLevel(String seclevel, String seclevelend) {
        String strLevel = "";
        if (seclevel.length() > 0 && seclevelend.length() > 0) {
            strLevel = seclevel + "-" + seclevelend;
        }
        return strLevel;
    }

    public String getScheduleShareType(String sharetype, String languageid) {
        String sharetypeName = "";
        if ("1".equals(sharetype)) {
            sharetypeName = SystemEnv.getHtmlLabelName(20081, Util.getIntValue(languageid));
        } else if ("2".equals(sharetype)) {
            sharetypeName = SystemEnv.getHtmlLabelName(20082, Util.getIntValue(languageid));
        }
        return sharetypeName;
    }

    /**
     * 获取批量操作里的字段数据
     *
     * @param fieldvalue
     * @param otherPara
     * @return
     */
    public String getBatchDefineContent(String fieldvalue, String otherPara) {
        String hfmFieldValue = "";
        try {
            String[] splitStr = Util.splitString(otherPara, "+");
            int userid = Util.getIntValue(splitStr[0]);
            String dmlurl = splitStr[1];
            String fieldhtmltype = splitStr[2];
            String detailtype = splitStr[3];
            String fieldid = splitStr[4];
            User user = User.getUser(userid, 0);
            if (fieldhtmltype.equals("3")) {
                HrmFieldManager hrmFieldManager = new HrmFieldManager();
                String tmpFieldValue = String.valueOf(fieldvalue);
                if (tmpFieldValue.length() > 0) {
                    hfmFieldValue = hrmFieldManager.getFieldvalue(user, dmlurl, Util.getIntValue(fieldid), Util.getIntValue(fieldhtmltype), Util.getIntValue(detailtype), tmpFieldValue, 0);
                }
            } else {
                hfmFieldValue = fieldvalue;
            }
        } catch (Exception e) {
            hfmFieldValue = fieldvalue;
            writeLog("getBatchDefineContent exception:字段otherPara" + otherPara + "报错" + e.getMessage());
        }
        return hfmFieldValue;
    }

    /**
     * 获取某个人员的工资项（类型为工资时）时值
     *
     * @param resourceId 人员ID
     * @param itemId     工资项ID
     * @return
     */
    public String getSalaryItem1(String resourceId, String itemId) {
        String value = "";
        String isBatch = "";
        if (resourceId.equals("") || itemId.equals("")) {
            return value;
        }
        RecordSet recordSet = new RecordSet();
        recordSet.executeQuery("select salary from HrmSalaryPersonality where hrmid=" + resourceId + " and itemid=" + itemId);
        if (recordSet.next()) {
            value = Util.null2String(recordSet.getString("salary")).trim();
        }
        recordSet.executeQuery("select resourcepay,isBatch from HrmSalaryResourcePay where resourceid=" + resourceId + " and itemid=" + itemId);
        if (recordSet.next()) {
            isBatch = Util.null2String(recordSet.getString("isBatch")).trim();
            if ("0".equals(isBatch)) {
                value = Util.null2String(recordSet.getString("resourcepay")).trim();
            }
        }
        return value;
    }

    /**
     * 获取（薪酬指标数据维护）日志targetName显示名
     *
     * @param param
     * @return
     */
    public String getTargetMaintLogName(String param) {
        String[] paramArr = param.split("-");
        SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
        String subcompanyName = subCompanyComInfo.getSubCompanyname(paramArr[0]);
        return subcompanyName + '-' + paramArr[1] + '-' + paramArr[2];
    }

    /**
     * 获取（工资单）日志targetName显示名
     *
     * @param param
     * @return
     */
    public String getSalaryManageLogName(String param) {
        String[] paramArr = param.split("-");
        SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
        String subcompanyName = subCompanyComInfo.getSubCompanyname(paramArr[0]);
        return subcompanyName + '-' + paramArr[1];
    }

    /**
     * 根据传入的表单名称和流程id联合判断获取表单名称
     *
     * @param labelname
     * @param field001
     * @return
     */
    public String getFormLabelName(String labelname, String field001) {
        String formName = labelname;
        if (field001.length() > 0 && labelname.length() == 0) {
            RecordSet rs = new RecordSet();
            //如果workflow_bill里没有名字，可能是旧表单
            rs.executeSql("select formname from workflow_formbase where id=(select formid from workflow_base where id =" + field001 + ")");
            if (rs.next()) {
                formName = rs.getString("formname");
            }
        }
        return formName;
    }

    /**
     * 工资项设置--工资(获取个人基准设置的金额)
     *
     * @param resourceId
     * @param itemId
     * @return
     */
    public String getResourcePay(String resourcePay, String resourceId, String itemId) {
        String resultValue = "";//工资项的值
        int isBatch = 1;
        if (itemId.length() < 0) {
            return resultValue;
        }
        String sql = "select isbatch,resourcePay from HrmSalaryResourcePay where resourceId=? and itemId=?";
        RecordSet recordSet = new RecordSet();
        recordSet.executeQuery(sql, resourceId, itemId);
        if (recordSet.next()) {
            resultValue = recordSet.getString("resourcePay");
            isBatch = Util.getIntValue(recordSet.getString("isBatch"), 0);
        }
        if (isBatch == 1) {
            sql = "select * from HrmSalaryPersonality where hrmid=? and itemid=?";
            recordSet.executeQuery(sql, resourceId, itemId);
            if (recordSet.next()) {
                resultValue = recordSet.getString("salary");
            }
        }
        return resultValue;
    }


    /**
     * 获取婚姻状态的显示名称
     *
     * @param maritalStatus
     * @param languageId
     * @return
     */
    public String getMaritalStatusShow(String maritalStatus, String languageId) {
        String maritalStatusShow = "";
        int language = Util.getIntValue(languageId, 7);
        if ("0".equals(maritalStatus)) {
            maritalStatusShow = SystemEnv.getHtmlLabelName(470, language);
        } else if ("1".equals(maritalStatus)) {
            maritalStatusShow = SystemEnv.getHtmlLabelName(471, language);
        } else if ("2".equals(maritalStatus)) {
            maritalStatusShow = SystemEnv.getHtmlLabelName(472, language);
        }
        return maritalStatusShow;
    }

    /**
     * 获取人员密级的显示名称
     *
     * @param showName
     * @param otherpara
     * @return
     */
    public String getClassificationShowName(String showName, String otherpara) {
        String secLevel = otherpara.split("\\+")[0];
        String languageId = otherpara.split("\\+")[1];
        int language = Util.getIntValue(languageId, 7);
        String sql = "select * from UserClassification where secLevel=" + secLevel;
        RecordSet recordSet = new RecordSet();
        recordSet.executeQuery(sql);
        if (recordSet.next()) {
            int showNameLabel = Util.getIntValue(recordSet.getString("showNameLabel"), 0);
            String customShowName = Util.formatMultiLang(recordSet.getString("customShowName"), languageId);
            showName = recordSet.getString("showName");

            if (!customShowName.equals("")) {
                showName = customShowName;
            } else if (showNameLabel != 0) {
                showName = SystemEnv.getHtmlLabelName(showNameLabel, language);
            }
        }
        return showName;
    }

    /**
     * 获取资源密级的显示名称
     * @param showName
     * @param otherpara
     * @return
     */
    public String getResClassificationShowName(String showName, String otherpara){
        String secLevel = otherpara.split("\\+")[0];
        String languageId = otherpara.split("\\+")[1];
        int language = Util.getIntValue(languageId, 7);
        String sql = "select * from ResourceClassification where secLevel=" + secLevel;
        RecordSet recordSet = new RecordSet();
        recordSet.executeQuery(sql);
        if (recordSet.next()) {
            int showNameLabel = Util.getIntValue(recordSet.getString("showNameLabel"), 0);//默认显示名称
            String customShowName = Util.formatMultiLang(recordSet.getString("customShowName"), languageId);//自定义显示名称
            showName = recordSet.getString("showName");

            if (!customShowName.equals("")) {
                showName = customShowName;
            } else if (showNameLabel != 0) {
                showName = SystemEnv.getHtmlLabelName(showNameLabel, language);
            }
        }
        return showName;
    }

    /**
     * 获取资源密级可选项显示名称
     *
     * @param optionalResourceSecLevel
     * @param languageId
     * @return
     */
    public String getOptionalResourceSecLevelShow(String optionalResourceSecLevel, String languageId) {
        String showName = "";
        int language = Util.getIntValue(languageId, 7);
        String[] secLevelArr = optionalResourceSecLevel.split(",");
        for (int i = 0; i < secLevelArr.length; i++) {
            String secLevel = secLevelArr[i];
            String sql = "select * from ResourceClassification where secLevel=" + secLevel;
            RecordSet recordSet = new RecordSet();
            recordSet.executeQuery(sql);
            if (recordSet.next()) {
                int showNameLabel = Util.getIntValue(recordSet.getString("showNameLabel"), 0);

                showName += "," + SystemEnv.getHtmlLabelName(showNameLabel, language);
            }
        }
        return showName.length() > 0 ? showName.substring(1) : showName;
    }

    /**
     * 【账户中心--安全设置--账户锁定】获取白名单的对象名称
     *
     * @param id
     * @param otherpara
     * @return
     */
    public String getObjNameOfWhiteList(String id, String otherpara) {
        String objName = "";
        try {
            int languageId = Util.getIntValue(otherpara, 7);
            RecordSet rs = new RecordSet();
            rs.executeSql("select * from HrmWhiteListOfSecSetting where id =" + id);
            if (rs.next()) {
                String objectType = rs.getString("objectType");
                if ("1".equals(objectType)) {
                    ResourceComInfo resourceComInfo = new ResourceComInfo();
                    objName = resourceComInfo.getResourcename(rs.getString("objectId"));
                } else if ("2".equals(objectType)) {
                    SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
                    objName = subCompanyComInfo.getSubCompanyname(rs.getString("objectId"));

                } else if ("3".equals(objectType)) {
                    DepartmentComInfo departmentComInfo = new DepartmentComInfo();
                    objName = departmentComInfo.getDepartmentname(rs.getString("objectId"));
                } else if ("4".equals(objectType)) {
                    RolesComInfo rComInfo = new RolesComInfo();
                    String st = (rs.getString("roleLevel").equals("2")) ? SystemEnv.getHtmlLabelName(140, languageId) : (rs.getString("roleLevel").equals("1") ? SystemEnv.getHtmlLabelName(141, languageId) : SystemEnv.getHtmlLabelName(124, languageId));
                    objName = rComInfo.getRolesRemark(rs.getString("objectId")) + "/" + st;
                } else if ("7".equals(objectType)) {
                    JobTitlesComInfo rComInfo = new JobTitlesComInfo();
                    SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
                    DepartmentComInfo departmentComInfo = new DepartmentComInfo();
                    String st = "";
                    if (rs.getString("jobtitLelevel").equals("0")) {
                        st = "/" + SystemEnv.getHtmlLabelName(140, languageId);
                    } else if (rs.getString("jobtitLelevel").equals("1")) {
                        st = "/" + SystemEnv.getHtmlLabelName(19437, languageId) + "(" + subCompanyComInfo.getSubCompanyname(rs.getString("subcomIdOfJob")) + ")";
                    } else if (rs.getString("jobtitLelevel").equals("2")) {
                        st = "/" + SystemEnv.getHtmlLabelName(19438, languageId) + "(" + departmentComInfo.getDepartmentname(rs.getString("deptIdOfJob")) + ")";
                    }
                    objName = rComInfo.getJobTitlesname(rs.getString("objectId")) + st;
                } else if("5".equals(objectType)) {
                    objName = SystemEnv.getHtmlLabelName(1340, languageId);
                }
            }
        } catch (Exception e) {
            // TODO: handle exception
            e.printStackTrace();
        }
        return objName;
    }

  /**
   * 跳转到矩阵批量维护页面
   * @param uuid
   * @param otherpara
   * @return
   */
  public String getMatrixColDetail(String uuid, String otherpara){
    int lan = 7;
    String fromid = "";
    String matrixid = "";
    List<String> otherparas = Util.splitString2List(otherpara,"+");
    if(otherparas != null && otherparas.size() == 3){
      matrixid = otherparas.get(0);
      lan = Util.getIntValue(otherparas.get(1));
      fromid = otherparas.get(2);
    }
    if(fromid.length() == 0 || matrixid.length() == 0){
      return "";
    }
    String matrixname = "";
    String lastname = "";
    String detail = "";
    String title = SystemEnv.getHtmlLabelName(367, Util.getIntValue(otherpara,lan));
    try{
      MatrixinfoComInfo matrixinfoComInfo = new MatrixinfoComInfo();
      ResourceComInfo rc = new ResourceComInfo();
      matrixname = matrixinfoComInfo.getName(matrixid);
      lastname = rc.getLastname(fromid);
      String matrixname_lan = URLEncoder.encode(Util.formatMultiLang(matrixname,""+lan), "UTF-8");
      String lastname_lan = URLEncoder.encode(Util.formatMultiLang(lastname,""+lan), "UTF-8");
      detail = "<a href='/spa/hrm/engine.html#/hrmengine/matrixadjust?needSearch=1&matrixid="+matrixid+"&matrixname="+matrixname_lan+
          "&resourceid="+fromid+"&resourcename="+lastname_lan+" ' target='_blank'>" + title + "</a>";
    }catch (Exception e){
      e.printStackTrace();
    }


    return detail;
  }

  /**
   * 根据fromid 获取对应矩阵里的sql
   * @param matrixid
   * @param fromid
   * @return
   */
  public String getMatrixColDetailSql(String matrixid, String fromid,List<String> fieldsList){

    int result = 0;
    RecordSet rs = new RecordSet();
    String dbtype = rs.getDBType();
    MatrixFieldsComInfo matrixFieldsComInfo = new MatrixFieldsComInfo();

    String sqlwhere = "";
    ConcurrentHashMap<String, Object> matrixFieldsMap = matrixFieldsComInfo.getFieldsByMatrixid(matrixid);
    if(matrixFieldsMap != null && matrixFieldsMap.containsKey("1")){
      List<Object> fieldList = (List<Object>) matrixFieldsMap.get("1");
      for(int k = 0 ; k < fieldList.size() ; k++){
        if(fieldList.get(k) != null){
          ConcurrentHashMap<String, Object> tmp_fieldMap = (ConcurrentHashMap<String, Object>) fieldList.get(k);
          String id = Util.null2String(tmp_fieldMap.get("id"));
          String fieldname = Util.null2String(tmp_fieldMap.get("fieldname"));
          fieldsList.add(fieldname);
          if(k == 0){
            if (dbtype.indexOf("sqlserver") >= 0) {
              sqlwhere += " where ','+"+fieldname+",' like '%,"+fromid+",%'";
            }else if (dbtype.indexOf("mysql") >= 0) {
              sqlwhere += " where concat(',',"+fieldname+",',')  like '%,"+fromid+",%'";
            }else{
              sqlwhere += " where ','||"+fieldname+"||',' like '%,"+fromid+",%'";
            }
          }else{
            if (dbtype.indexOf("sqlserver") >= 0) {
              sqlwhere += " or ','+"+fieldname+",' like '%,"+fromid+",%'";
            }else if (dbtype.indexOf("mysql") >= 0) {
              sqlwhere += " or concat(',',"+fieldname+",',')  like '%,"+fromid+",%'";
            }else{
              sqlwhere += " or ','||"+fieldname+"||',' like '%,"+fromid+",%'";
            }

          }
        }
      }
    }
    return sqlwhere;
  }

  /**
   * 根据fromid 获取对应矩阵里的数量
   * @param matrixid
   * @param fromid
   * @return
   */
  public String getMatrixColDetailCount(String matrixid, String fromid){

    int result = 0;
    RecordSet rs = new RecordSet();
    String dbtype = rs.getDBType();
    MatrixFieldsComInfo matrixFieldsComInfo = new MatrixFieldsComInfo();

    String tablename = "matrixtable_"+matrixid;
    String sqlwhere = "";
    List<String> fieldnames = new ArrayList<>();
    ConcurrentHashMap<String, Object> matrixFieldsMap = matrixFieldsComInfo.getFieldsByMatrixid(matrixid);
    if(matrixFieldsMap != null && matrixFieldsMap.containsKey("1")){
      List<Object> fieldList = (List<Object>) matrixFieldsMap.get("1");
      for(int k = 0 ; k < fieldList.size() ; k++){
        if(fieldList.get(k) != null){
          ConcurrentHashMap<String, Object> tmp_fieldMap = (ConcurrentHashMap<String, Object>) fieldList.get(k);
          String id = Util.null2String(tmp_fieldMap.get("id"));
          String fieldname = Util.null2String(tmp_fieldMap.get("fieldname"));
          fieldnames.add(fieldname);
          if(k == 0){
            if (dbtype.indexOf("sqlserver") >= 0) {
              sqlwhere += " where ','+"+fieldname+"+',' like '%,"+fromid+",%'";
            }else if (dbtype.indexOf("mysql") >= 0) {
              sqlwhere += " where concat(',',"+fieldname+",',')  like '%,"+fromid+",%'";
            }else{
              sqlwhere += " where ','||"+fieldname+"||',' like '%,"+fromid+",%'";
            }
          }else{
            if (dbtype.indexOf("sqlserver") >= 0) {
              sqlwhere += " or ','+"+fieldname+"+',' like '%,"+fromid+",%'";
            }else if (dbtype.indexOf("mysql") >= 0) {
              sqlwhere += " or concat(',',"+fieldname+",',')  like '%,"+fromid+",%'";
            }else{
              sqlwhere += " or ','||"+fieldname+"||',' like '%,"+fromid+",%'";
            }
          }
        }
      }
    }
    if(sqlwhere.length() > 0){
      String sql = "select * from "+tablename+" "+sqlwhere;
      rs.executeQuery(sql);
      rs.writeLog("getMatrixColDetailCount:sql:"+sql);
      while (rs.next()){
        for(String fieldname : fieldnames){
          String fieldvalue = rs.getString(fieldname);
          if((","+fieldvalue+",").indexOf((","+fromid+",")) > -1){
            result += 1;
          }
        }
      }
    }
    return result+"";
  }


  /**
   * 获取 权限调整里满足条件的矩阵的id
   * @param fromid
   * @return
   */
  public String getMatrixidsByAdjust(String fromid){

    String matrixids = "";
    MatrixinfoComInfo matrixinfoComInfo = new MatrixinfoComInfo();
    while(matrixinfoComInfo.next()){
      String matrixid = matrixinfoComInfo.getId();
      String result = getMatrixColDetailCount(matrixid, fromid);
      if(Util.getIntValue(result, 0) > 0){
        matrixids += ","+matrixid;
      }
    }
    if(matrixids.length() > 0){
      matrixids = matrixids.substring(1);
    }
    return matrixids;
  }

    /**
     * 获取薪酬指标数据维护的总人数
     *
     * @param empNum
     * @param id
     * @return
     */
    public String getEmpNum(String empNum, String id) {
        String[] paramArr = id.split(":");
        String subcompanyId = "";
        String departmentId = "";
        if ("subcompany".equals(paramArr[0])) {
            subcompanyId = paramArr[1];
        } else {
            departmentId = paramArr[1];
            DepartmentComInfo departmentComInfo = new DepartmentComInfo();
            subcompanyId = departmentComInfo.getSubcompanyid1(departmentId);
        }

        String allChildSubcompanyId = "";
        SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
        allChildSubcompanyId = subCompanyComInfo.getAllChildSubcompanyId(subcompanyId, allChildSubcompanyId);
        String allSubcompanyId = subcompanyId + allChildSubcompanyId;

        String sql = "select count(*) from HrmResource where status in (0,1,2,3) and subcompanyId1 in (" + allSubcompanyId + ")";
        RecordSet recordSet = new RecordSet();
        recordSet.executeQuery(sql);
        if (recordSet.next()) {
            empNum = recordSet.getString(1);
        }
        return empNum;
    }

    /**
     * 获取客户端类型
     *
     * @param clientType
     * @param userLanguage
     * @return
     */
    public String getClientTypeShow(String clientType, String userLanguage) {
        String clientTypeShow = "";
        try {
            if ("0".equals(clientType)) {
                clientTypeShow = "";
            } else if ("1".equals(clientType)) {
                clientTypeShow = "PC";
            } else if ("2".equals(clientType)) {
                clientTypeShow = SystemEnv.getHtmlLabelName(387689, Util.getIntValue(userLanguage, 7));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return clientTypeShow;
    }

    public String getRightTypeShow(String rightType, String otherParams) {
        String rightTypeShow = "";
        try {
            String[] otherParamsArr = otherParams.split("\\+");
            rightTypeShow = otherParamsArr[0];
            String userLanguage = otherParamsArr[1];
            rightTypeShow = Util.null2String(rightTypeShow, userLanguage);
            if (rightTypeShow == null || rightTypeShow.equals("")) {
                rightTypeShow = rightType;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return rightTypeShow;
    }


    /**
     * XSS处理一下
     *
     * @param relatedName
     * @return
     */
    public String getCleanRelatedName(String relatedName) {
      return SecurityMethodUtil.textXssClean(relatedName);
    }

    /**
     * XSS处理一下
     *
     * @param relatedName
     * @return
     */
    public String getCleanRelatedNameSignCheck(String relatedName, String otherpara) {
        relatedName = SecurityMethodUtil.textXssClean(relatedName);
        String str[] = Util.splitString(otherpara, "+");
        String id = str[0];
        String userLanguage = str[1];
        String date = "";
        String time = "";
        String relatedid =  "";
        String clientaddress = "";
        String operateuserid = "";
        String operatetype = "";
        String hashData = "";
        String signData = "";

        String sql = " select id, relatedid, relatedName, operateType, operateUserId, operateDate, operateTime, clientAddress,clientType, hashData, signData from hrmsysmaintenancelog where id=? ";
        RecordSet rs = new RecordSet();
        rs.executeQuery(sql,id);
        if(rs.next()){
            date = rs.getString("operateDate");
            time = rs.getString("operateTime");
            relatedid = rs.getString("relatedid");
            clientaddress = rs.getString("clientAddress");
            operateuserid = rs.getString("operateUserId");
            operatetype = rs.getString("operateType");
            hashData = Util.null2String(rs.getString("hashData"));
            signData = Util.null2String(rs.getString("signData"));
        }
        String concatStr = SystemSignCheckUtil.concatParas(Util.null2String(relatedid), Util.null2String(clientaddress), Util.null2String(date), Util.null2String(time), Util.null2String(operateuserid), Util.null2String(operatetype));
        if ("".equals(hashData) && "".equals(signData)) {
            return relatedName;
        }
        boolean isPassCheck = SystemSignCheckUtil.signVerifyCheck(concatStr, hashData,signData, false);
        if(!isPassCheck){
            relatedName  = relatedName+"<span style='color: red;'>("+SystemEnv.getHtmlLabelName(536378, Util.getIntValue(userLanguage,7))+")</span>";
        }
        return relatedName;
    }

    public String getRightNameNew(String rightid, String otherpara) {
        String rightname = "";
        String str[] = Util.splitString(otherpara, "+");
        String id = str[0];
        String language = str[1];
        String roleLevel = "";
        String hashData = "";
        String signData = "";

        String sql = " select roleLevel, hashData, signData from systemrightroles where id=? ";
        RecordSet rs = new RecordSet();
        rs.executeQuery(sql,id);
        if(rs.next()){
            roleLevel = Util.null2String(rs.getString("roleLevel"));
            hashData = Util.null2String(rs.getString("hashData"));
            signData = Util.null2String(rs.getString("signData"));
        }
        RightComInfo rightComInfo = new RightComInfo();
        rightname = rightComInfo.getRightname(rightid, language);
        // 验签 true为通过(如果老数据没有加签的不校验)
        EncryptorAdaptationUtil encryptUtil = new EncryptorAdaptationUtil();
        return ((StringUtils.isEmpty(hashData) && StringUtils.isEmpty(signData)) ||
                encryptUtil.verifySign(roleLevel + "#" + rightid, hashData, signData, SignModuleType.roles)) ? rightname : rightname  +"<span style='color: red;'>("+SystemEnv.getHtmlLabelName(536378, Util.getIntValue(language,7))+")</span>";
    }

    public String getSubcompanyNameCheckSign(String subcompanyname, String otherpara) {
        String str[] = Util.splitString(otherpara, "+");
        String id = str[0];
        String language = str[1];
        String roleId = "";
        String subcompanyId = "";
        String roleLevel = "";
        String hashData = "";
        String signData =  "";

        String sql = " select roleid,subcompanyId,rightlevel, hashData, signData from sysrolesubcomright where id=? ";
        RecordSet rs = new RecordSet();
        rs.executeQuery(sql,id);
        if(rs.next()){
            roleId = Util.null2String(rs.getString("roleid"));
            subcompanyId = Util.null2String(rs.getString("subcompanyid"));
            roleLevel = Util.null2String(rs.getString("rightlevel"));
            hashData = Util.null2String(rs.getString("hashData"));
            signData = Util.null2String(rs.getString("signData"));
        }

        // 验签 true为通过(如果老数据没有加签的不校验)
        EncryptorAdaptationUtil encryptUtil = new EncryptorAdaptationUtil();
        boolean flag =  ((StringUtils.isEmpty(hashData) && StringUtils.isEmpty(signData)) ||
                encryptUtil.verifySign(roleId + "#" +subcompanyId+ "#" + roleLevel , hashData, signData, SignModuleType.roles));
        return flag ? subcompanyname : subcompanyname +"<span style='color: red;'>("+SystemEnv.getHtmlLabelName(536378, Util.getIntValue(language,7))+")</span>";
    }

    public String getResourceTypeNew(String resourcetype, String otherpara) {
        String result = "";
        String str[] = Util.splitString(otherpara, "+");
        String id = str[0];
        String language = str[1];
        String resourceid = "";
        String seclevelfrom = "";
        String seclevelto = "";
        String rolelevel = "";
        String hashData = "";
        String signData = "";

        String sql = " select resourceid, seclevelfrom, seclevelto, rolelevel, hashData, signData from HrmRoleMembers where id=? ";
        RecordSet rs = new RecordSet();
        rs.executeQuery(sql,id);
        if(rs.next()){
            resourceid = Util.null2String(rs.getString("resourceid"));
            seclevelfrom = Util.null2String(rs.getString("seclevelfrom"));
            seclevelto = Util.null2String(rs.getString("seclevelto"));
            rolelevel = Util.null2String(rs.getString("rolelevel"));
            hashData = Util.null2String(rs.getString("hashData"));
            signData = Util.null2String(rs.getString("signData"));
        }
        // 验签 true为通过(如果老数据没有加签的不校验)
        EncryptorAdaptationUtil encryptUtil = new EncryptorAdaptationUtil();
        boolean flag = (StringUtils.isEmpty(hashData) && StringUtils.isEmpty(signData)) ||
                encryptUtil.verifySign(resourcetype + "#" + resourceid + "#" + seclevelfrom + "#" + seclevelto + "#" + rolelevel, hashData, signData, SignModuleType.roles);
        if (resourcetype.length() == 0) {
            return flag ? result : result +"<span style='color: red;'>("+SystemEnv.getHtmlLabelName(536378, Util.getIntValue(language,7))+")</span>";
        }
        switch (Util.getIntValue(resourcetype)) {
            case 1:
                result = SystemEnv.getHtmlLabelName(179, Util.getIntValue(language, 7));
                break;
            case 2:
                result = SystemEnv.getHtmlLabelName(141, Util.getIntValue(language, 7));
                break;
            case 3:
                result = SystemEnv.getHtmlLabelName(124, Util.getIntValue(language, 7));
                break;
            case 5:
                result = SystemEnv.getHtmlLabelName(6086, Util.getIntValue(language, 7));
                break;
            case 6:
                result = SystemEnv.getHtmlLabelName(1340, Util.getIntValue(language, 7));
                break;
            case 7:
                result = SystemEnv.getHtmlLabelName(1507, Util.getIntValue(language, 7));
                break;
            case 8:
                result = SystemEnv.getHtmlLabelName(16139, Util.getIntValue(language, 7));
                break;
            default:
                break;
        }
        return flag ? result : result +"<span style='color: red;'>("+SystemEnv.getHtmlLabelName(536378, Util.getIntValue(language,7))+")</span>";
    }
}
